#include "extension.h"
#include "CDetour/detours.h"
#include "activity.h"
#include "shareddefs.h"
#include "hl2_shareddefs.h"
#include "npcevent.h"
#include "const.h"
#include "ammodef.h"
#include "fmtstr.h"
#include "enum.h"
#include "define.h"
#include "convar_sm.h"
#include "func.h"

hl2mp g_Interface;
SMEXT_LINK(&g_Interface);

CGlobalVars *gpGlobals;

IGameConfig *g_pGameConf = NULL;
IServerGameEnts *gameents = NULL;
IServerTools *servertools = NULL;
IEngineTrace *enginetrace = NULL;
IEffects *g_pEffects = NULL;
//IUniformRandomStream *engrandom = NULL;

CSharedEdictChangeInfo *g_pSharedChangeInfo = NULL;

CDetour *AddAmmoTypeHL2MP_CDetour = NULL;
CDetour *UTIL_GetLocalPlayer_CDetour = NULL;
CDetour *SelectSchedule_CDetour = NULL;
CDetour *InitDefaultAIRelationshipsHL2MP_CDetour = NULL;
CDetour *CapabilitiesGet_CDetour = NULL;
CDetour *Weapon_TranslateActivity_CDetour = NULL;
CDetour *UTIL_SetModel_CDetour = NULL;
CDetour *EmitSound_CDetour = NULL;
CDetour *FireBullets_CDetour = NULL;
CDetour *GetShootEnemyDir_CDetour = NULL;
CDetour *ShouldCollide_CDetour = NULL;
CDetour *Operator_HandleAnimEvent_CDetour = NULL;
CDetour *HandleAnimEvent_Antlion_CDetour = NULL;
CDetour *FindNearestNPC_CDetour = NULL;
CDetour *ChangeTeam_CDetour = NULL;
CDetour *GetSpitVector_CDetour = NULL;
CDetour *BugBaitTouch_CDetour = NULL;

DETOUR_DECL_MEMBER10(AddAmmoType, void, const char*, name, int, damageType, int, tracerType, int, plr_dmg, int, npc_dmg, int, carry, float, physicsForceImpulse, int, nFlags, int, minSplashSize, int, maxSplashSize)
{
	static bool i = false;
	if(!i)
	{
		i=true;
		DETOUR_MEMBER_CALL(AddAmmoType)("StriderMinigun",DMG_BULLET,TRACER_LINE,5,15,15,1.0 * 750 * 12,AMMO_FORCE_DROP_IF_CARRIED,4,8);
		DETOUR_MEMBER_CALL(AddAmmoType)("StriderMinigunDirect",DMG_BULLET,TRACER_LINE,2,2,15,1.0 * 750 * 12,AMMO_FORCE_DROP_IF_CARRIED,4,8);
		DETOUR_MEMBER_CALL(AddAmmoType)("HelicopterGun",DMG_BULLET,TRACER_LINE_AND_WHIZ,3,3,255,BULLET_IMPULSE(400, 1225),AMMO_FORCE_DROP_IF_CARRIED | AMMO_INTERPRET_PLRDAMAGE_AS_DAMAGE_TO_PLAYER,4,8);
		DETOUR_MEMBER_CALL(AddAmmoType)("AirboatGun",DMG_AIRBOAT,TRACER_LINE,3,3,0,BULLET_IMPULSE(10, 600),0,4,8); 
		DETOUR_MEMBER_CALL(AddAmmoType)("SniperRound",DMG_BULLET | DMG_SNIPER,TRACER_NONE,120,120,0,BULLET_IMPULSE(650, 6000),0,4,8);
		DETOUR_MEMBER_CALL(AddAmmoType)("CombineCannon",DMG_BULLET,TRACER_LINE,6,40,0,1.5 * 750 * 12,0,4,8);
		DETOUR_MEMBER_CALL(AddAmmoType)("CombineHeavyCannon",DMG_BULLET,TRACER_LINE,40,40,0,10 * 750 * 12,AMMO_FORCE_DROP_IF_CARRIED,4,8);
	}
	if(strcmpi(name,"Pistol") == 0)
	{
		npc_dmg = 10;
	}
	else if(strcmpi(name,"AR2") == 0)
	{
		npc_dmg = 10;
		carry = 140;
	}
	else if(strcmpi(name,"RPG_Round") == 0)
	{
		carry = 5;
	}
	else if(strcmpi(name,"Buckshot") == 0)
	{
		npc_dmg = 10;
		carry = 40;
	}
	DETOUR_MEMBER_CALL(AddAmmoType)(name,damageType,tracerType,plr_dmg,npc_dmg,carry,physicsForceImpulse,nFlags,minSplashSize,maxSplashSize);
	return;
}

DETOUR_DECL_STATIC0(UTIL_GetLocalPlayer, CBaseEntity *)
{
	for(int i=1;i<=gpGlobals->maxClients;i++)
	{
		CBaseEntity *pPlayer = UTIL_PlayerByIndex(i);
		if(pPlayer) {
			return pPlayer;
		}
	}
	return NULL;
}

DETOUR_DECL_STATIC1(SelectSchedule, int, CBaseEntity *, entity)
{	
	CBaseEntity *m_hEnemy = GetEntPropEnt(entity,"m_hEnemy");
	if(m_hEnemy == NULL || HasCondition(entity,COND_ENEMY_DEAD)) {
		SetEntPropEnt(entity,"m_hEnemy",NULL);
		return 89;
	}
	bool m_fWeaponLoaded = GetEntProp(entity,"m_fWeaponLoaded",true);
	if(!m_fWeaponLoaded) {
		return 51;
	}
	bool m_fEnabled = GetEntProp(entity,"m_fEnabled",true);
	if(!m_fEnabled) {
		return 54;
	}
	if(HasCondition(entity,COND_LOST_ENEMY)) {
		return 89;
	}
	if(HasCondition(entity,COND_CAN_RANGE_ATTACK1)) {
		return 43;
	}
	return 89;
}

DETOUR_DECL_STATIC0(InitDefaultAIRelationshipsHL2MP, void)
{
	PrecacheParticleSystem("blood_impact_antlion_01");
	InitDefaultAIRelationships();
}

DETOUR_DECL_STATIC1(CapabilitiesGet, int, CBaseEntity *, entity)
{
	if(FClassnameIs(entity,"weapon_stunstick") | FClassnameIs(entity,"weapon_crowbar")) {
		return 0x00008000;
	}
	return 0x00002000;
}

DETOUR_DECL_STATIC3(GetShootEnemyDir, Vector, CBaseEntity *, entity, Vector &, shootOrigin, bool, bNoisy)
{
	if(FClassnameIs(entity,"npc_vortigaunt")) {
		bNoisy = true;
	}
	return DETOUR_STATIC_CALL(GetShootEnemyDir)(entity,shootOrigin,bNoisy);
}

DETOUR_DECL_STATIC4(EmitSound, void, CBaseEntity *, entity, const char *, soundname, float, soundtime, float *, duration)
{
	DETOUR_STATIC_CALL(EmitSound)(entity,soundname,soundtime,duration);
}

DETOUR_DECL_STATIC2(FireBullets, void, CBaseEntity *, entity, FireBulletsInfo_t &, info)
{
	if(IsPlayer(entity)) {
		DETOUR_STATIC_CALL(FireBullets)(entity,info);
		return;
	}
	if(IsPlayer(info.m_pAttacker)) {
		DETOUR_STATIC_CALL(FireBullets)(entity,info);
		return;
	}
	trace_t tr;
	Vector vecAbsStart, vecAbsEnd, vecDir;
	float flVelocity = 0;
	int attachment = TRACER_DONT_USE_ATTACHMENT;
	bool bWhiz = false;
	int iEntIndex = 0;
	const char *szTracer = "Tracer";
	vecDir = info.m_vecDirShooting;
	info.m_vecSpread = vec3_origin;
	if(FClassnameIs(entity,"npc_combinegunship")) {
		info.m_vecDirShooting = GetShootEnemyDir(entity,info.m_vecSrc,true);
		vecDir = info.m_vecDirShooting;
	}
	else if(FClassnameIs(entity,"npc_helicopter")) {
		info.m_vecDirShooting = GetShootEnemyDir(entity,info.m_vecSrc,true);
		vecDir = GetActualShootTrajectory(entity,info.m_vecSrc);
		info.m_pAdditionalIgnoreEnt = NULL;
		edict_t *pEdict = gameents->BaseEntityToEdict(entity);
		if(pEdict) {
			iEntIndex = IndexOfEdict(pEdict);
		}
		attachment = 2;
		bWhiz = true;
		szTracer = "HelicopterTracer";
		info.m_vecSpread = VECTOR_CONE_3DEGREES;
	}
	else if(FClassnameIs(entity,"npc_turret_ceiling")) {
		szTracer = "AR2Tracer";
		EmitSound(entity,"NPC_CeilingTurret.Shoot",0.0,NULL);
	}
	else if(FClassnameIs(entity,"npc_turret_floor")) {
		szTracer = "AR2Tracer";
	}
	else if(FClassnameIs(entity,"prop_vehicle_apc")) {
		szTracer = "HelicopterTracer";
		info.m_vecSpread = VECTOR_CONE_3DEGREES;
	}
	else if(FClassnameIs(entity,"func_tank")) {
		info.m_vecDirShooting = GetShootEnemyDir(info.m_pAttacker,info.m_vecSrc,true);
		szTracer = "AR2Tracer";
		info.m_vecSpread = VECTOR_CONE_3DEGREES;
	}
	vecAbsStart = info.m_vecSrc;
	vecDir = ApplySpread(info.m_vecSpread,vecDir);
	vecAbsEnd = vecAbsStart + (vecDir * MAX_TRACE_LENGTH);
	UTIL_TraceLine(vecAbsStart,vecAbsEnd,MASK_SHOT,entity,0,&tr);
	if(FClassnameIs(entity,"npc_strider")) {
		if( tr.fraction != 1.0 ) {
			g_pEffects->EnergySplash( tr.endpos, tr.plane.normal ); 
		}
		szTracer = "StriderTracer";
		flVelocity = 5000;
	}
	else if(FClassnameIs(entity,"npc_combinegunship")) {
		flVelocity = 8000;
		bWhiz = true;
		szTracer = "GunshipTracer";
		if( tr.fraction != 1.0 ) {
			g_pEffects->EnergySplash( tr.endpos, tr.plane.normal ); 
		}
	}
	else if(FClassnameIs(entity,"npc_combinedropship")) {
		flVelocity = 16000;
		bWhiz = true;
		szTracer = "GunshipTracer";
		if( tr.fraction != 1.0 ) {
			g_pEffects->EnergySplash( tr.endpos, tr.plane.normal ); 
		}
	}
	CBaseEntity *m_hActiveWeapon = GetEntPropEnt(entity,"m_hActiveWeapon");
	if(m_hActiveWeapon != NULL) {
		if(FClassnameIs(m_hActiveWeapon,"weapon_ar2")) {
			szTracer = "AR2Tracer";
		}
		else {
			szTracer = "Tracer";
		}
		edict_t *pEdict = gameents->BaseEntityToEdict(m_hActiveWeapon);
		if(pEdict) {
			iEntIndex = IndexOfEdict(pEdict);
		}
		attachment = 1;
		bWhiz = true;
	}
	UTIL_Tracer(tr.startpos,tr.endpos,iEntIndex,attachment,flVelocity,bWhiz,szTracer,0);
	if( tr.fraction != 1.0 ) {
		DoImpactEffect(entity,tr,DMG_BULLET);
	}
	info.m_iTracerFreq = 0;
	DETOUR_STATIC_CALL(FireBullets)(entity,info);
}

DETOUR_DECL_STATIC3(Operator_HandleAnimEvent, void, CBaseEntity *, entity, animevent_t *, pEvent, CBaseEntity *, pOperator)
{
	if(pOperator != NULL) {
		if(IsPlayer(pOperator)) {
			return;
		}
	}
	else {
		return;
	}
	if(pEvent->event == EVENT_WEAPON_AR2_ALTFIRE) {
		EmitSound(pOperator,"Weapon_IRifle.Single",0.0,NULL);
		Vector vecSrc = Weapon_ShootPosition(pOperator);
		Vector m_vecAltFireTarget = GetEntPropVector(pOperator,"m_vecAltFireTarget");
		Vector vecAiming = m_vecAltFireTarget - vecSrc;
		VectorNormalize( vecAiming );
		Vector vecVelocity = vecAiming * 1000.0f;
		CreateCombineBall(vecSrc,vecVelocity,200.0,150.0,8.0,pOperator);
		return;
	}
	else if(pEvent->event == EVENT_WEAPON_SMG1) {
		if(FClassnameIs(entity,"weapon_rpg")) {
			CBaseEntity *m_hEnemy = GetEntPropEnt(pOperator,"m_hEnemy");
			if(m_hEnemy == NULL) {
				return;
			}
			Vector vecSrc = Weapon_ShootPosition(pOperator);
			vecSrc[2] += 25.0;
			Vector vecAiming = GetActualShootTrajectory(pOperator,vecSrc);
			QAngle vecAng;
			VectorAngles(vecAiming,vecAng);
			Vector vecForward(vecAng[0],vecAng[1],vecAng[2]);
			CBaseEntity *pMissile = (CBaseEntity *)servertools->CreateEntityByName("apc_missile");
			if(pMissile != NULL) {
				EmitSound(pOperator,"Weapon_RPG.NPC_Single",0.0,NULL);
				SetEntPropEnt(pMissile,"m_hOwnerEntity",pOperator);
				SetEntPropEnt(pMissile,"m_hOwner",pOperator);
				SetEntPropVector(pMissile,"m_vecAbsOrigin",vecSrc);
				SetEntPropVector(pMissile,"m_angRotation",vecForward);
				servertools->DispatchSpawn(pMissile);
			}
			return;
		}
		int m_iClip1 = GetEntProp(entity,"m_iClip1");
		SetEntProp(entity,"m_iClip1",m_iClip1-1);
		EmitSound(pOperator,"Weapon_SMG1.NPC_Single",0.0,NULL);
		FireBulletsInfo_t info;
		info.m_iTracerFreq = 2;
		info.m_vecSrc = Weapon_ShootPosition(pOperator);
		info.m_iShots = 1;
		info.m_vecDirShooting = GetActualShootTrajectory(pOperator,info.m_vecSrc);
		info.m_pAttacker = pOperator;
		info.m_iDamage = 1;
		info.m_iPlayerDamage = 5;
		info.m_bPrimaryAttack = true;
		info.m_flDamageForceScale = 0.5;
		info.m_iAmmoType = 1;
		info.m_vecSpread = vec3_origin;
		FireBullets(pOperator,info);
	}
	else if(pEvent->event == EVENT_WEAPON_AR2) {
		int m_iClip1 = GetEntProp(entity,"m_iClip1");
		SetEntProp(entity,"m_iClip1",m_iClip1-1);
		EmitSound(pOperator,"Weapon_AR2.NPC_Single",0.0,NULL);
		FireBulletsInfo_t info;
		info.m_iTracerFreq = 2;
		info.m_vecSrc = Weapon_ShootPosition(pOperator);
		info.m_iShots = 1;
		info.m_vecDirShooting = GetActualShootTrajectory(pOperator,info.m_vecSrc);
		info.m_pAttacker = pOperator;
		info.m_iDamage = 1;
		info.m_iPlayerDamage = 5;
		info.m_bPrimaryAttack = true;
		info.m_flDamageForceScale = 0.5;
		info.m_iAmmoType = 1;
		info.m_vecSpread = vec3_origin;
		FireBullets(pOperator,info);
	}
	else if(pEvent->event == EVENT_WEAPON_SHOTGUN_FIRE) {
		int m_iClip1 = GetEntProp(entity,"m_iClip1");
		SetEntProp(entity,"m_iClip1",m_iClip1-1);
		EmitSound(pOperator,"Weapon_Shotgun.NPC_Single",0.0,NULL);
		FireBulletsInfo_t info;
		info.m_iTracerFreq = 2;
		info.m_vecSrc = Weapon_ShootPosition(pOperator);
		info.m_iShots = 1;
		info.m_pAttacker = pOperator;
		info.m_iDamage = 1;
		info.m_iPlayerDamage = 5;
		info.m_bPrimaryAttack = true;
		info.m_flDamageForceScale = 0.5;
		info.m_iAmmoType = 1;
		info.m_vecSpread = vec3_origin;
		int shot = 4;
		while(shot--) {
			info.m_vecDirShooting = GetActualShootTrajectory(pOperator,info.m_vecSrc);
			FireBullets(pOperator,info);
		}
	}
	else if(pEvent->event == EVENT_WEAPON_PISTOL_FIRE) {
		int m_iClip1 = GetEntProp(entity,"m_iClip1");
		SetEntProp(entity,"m_iClip1",m_iClip1-1);
		EmitSound(pOperator,"Weapon_Pistol.NPC_Single",0.0,NULL);
		FireBulletsInfo_t info;
		info.m_iTracerFreq = 2;
		info.m_vecSrc = Weapon_ShootPosition(pOperator);
		info.m_iShots = 1;
		info.m_vecDirShooting = GetShootEnemyDir(pOperator,info.m_vecSrc,true);
		info.m_pAttacker = pOperator;
		info.m_iDamage = 5;
		info.m_iPlayerDamage = 6;
		info.m_bPrimaryAttack = true;
		info.m_flDamageForceScale = 0.5;
		info.m_iAmmoType = 1;
		info.m_vecSpread = vec3_origin;
		FireBullets(pOperator,info);
	}
	return;
}

DETOUR_DECL_STATIC4(GetSpitVector, bool, CBaseEntity *, entity, const Vector &, vecStartPos, const Vector &, vecTarget, Vector *, vecOut) {
	Vector vecToss = VecCheckThrowTolerance( entity, vecStartPos, vecTarget, 600.0, (10.0f*12.0f) );
	if ( vecToss == vec3_origin ) {
		vecToss = VecCheckThrowTolerance( entity, vecStartPos, vecTarget, 600.0 * 1.5f, (10.0f*12.0f) );
		if ( vecToss == vec3_origin )
			return false;
	}
	if ( vecOut ) {
		*vecOut = vecToss;
	}
	return true;
}

DETOUR_DECL_STATIC2(HandleAnimEvent_Antlion, void, CBaseEntity *, entity, animevent_t *, pEvent)
{
	int event = pEvent->event;
	if(event == EventList_IndexForName("AE_ANTLION_WORKER_SPIT")) {
		CBaseEntity *m_hEnemy = GetEntPropEnt(entity,"m_hEnemy");
		if(m_hEnemy == NULL) {
			DETOUR_STATIC_CALL(HandleAnimEvent_Antlion)(entity,pEvent);
			return;
		}
		Vector vSpitPos = GetAbsOrigin(entity);
		vSpitPos[2] += 10.0;
		Vector vTarget;
		if(HasCondition(entity,COND_ENEMY_FACING_ME) && UTIL_DistApprox(GetAbsOrigin(entity),GetAbsOrigin(m_hEnemy)) > (40*12)) {
			UTIL_PredictedPosition(m_hEnemy,0.5f,&vTarget); 
			Vector tmp = GetAbsOrigin(m_hEnemy);
			vTarget[2] = tmp[2];
		}
		else {
			vTarget = BodyTarget(m_hEnemy,vSpitPos,true);
		}
		vTarget[2] += RandomFloat( 0.0f, 32.0f );
		Vector	vecToss;				
		if ( GetSpitVector( entity, vSpitPos, vTarget, &vecToss ) == false ) {
			if ( GetSpitVector( entity, vSpitPos, GetEntPropVector(entity,"m_vSavePosition"), &vecToss ) == false ) {
				vecToss = vec3_origin;
			}
		}
		Vector vecToTarget = ( vTarget - vSpitPos );
		VectorNormalize( vecToTarget );
		float flVelocity = VectorNormalize( vecToss );
		float flCosTheta = DotProduct( vecToTarget, vecToss );
		float flTime = (vSpitPos-vTarget).Length2D() / ( flVelocity * flCosTheta );
		for ( int i = 0; i < 6; i++ )
		{
			CBaseEntity *pGrenade = (CBaseEntity *)servertools->CreateEntityByName( "npc_grenade_bugbait" );
			SetEntPropVector(pGrenade,"m_vecAbsOrigin",vSpitPos);
			SetEntPropVector(pGrenade,"m_angRotation",vec3_origin);
			SetEntPropEnt(pGrenade,"m_hOwnerEntity",entity);
			SetEntPropEnt(pGrenade,"m_hThrower",entity);
			SetEntPropEnt(pGrenade,"m_hOwner",entity);
			SetEntProp(pGrenade,"m_CollisionGroup",HL2COLLISION_GROUP_SPIT,false,true);
			servertools->SetKeyValue( pGrenade, "classname", "grenade_spit" );
			servertools->DispatchSpawn( pGrenade );
			if ( i == 0 )
			{
				SetEntProp(pGrenade,"m_iTeamNum",3);
				EmitSound(pGrenade,"NPC_Antlion.PoisonBall",0.0,NULL);
				SetEntPropVector(pGrenade,"m_vecAbsVelocity",vecToss * flVelocity);
			}
			else
			{
				SetEntPropVector(pGrenade,"m_vecAbsVelocity",( vecToss + RandomVector( -0.035f, 0.035f ) ) * flVelocity);
			}
			CBaseEntity *m_hSpitEffect = (CBaseEntity *)servertools->CreateEntityByName( "env_smoketrail" );
			if ( m_hSpitEffect != NULL )
			{
				servertools->SetKeyValue(m_hSpitEffect, "endcolor", "255 255 0" );
				servertools->SetKeyValue(m_hSpitEffect, "startcolor", "0 255 0" );
				servertools->DispatchSpawn( m_hSpitEffect );
				SetEntPropVector(m_hSpitEffect,"m_vecOrigin",vSpitPos);
				SetParent( m_hSpitEffect,pGrenade );
			}
		}
		DispatchParticleEffect( GetParticleSystemIndex("blood_impact_antlion_01"), vSpitPos, vec3_origin, vec3_origin, NULL ); 
		EmitSound(entity,"NPC_Antlion.PoisonShoot",0.0,NULL);
	}
	DETOUR_STATIC_CALL(HandleAnimEvent_Antlion)(entity,pEvent);
}

DETOUR_DECL_STATIC3(Weapon_TranslateActivity, Activity, CBaseEntity *, entity, Activity, baseAct, bool *, pRequired)
{
	if(IsPlayer(entity)) {
		return DETOUR_STATIC_CALL(Weapon_TranslateActivity)(entity,baseAct,pRequired);
	}
	CBaseEntity *m_hActiveWeapon = GetEntPropEnt(entity,"m_hActiveWeapon");
	if(m_hActiveWeapon == NULL) {
		return DETOUR_STATIC_CALL(Weapon_TranslateActivity)(entity,baseAct,pRequired);
	}
	if(FClassnameIs(m_hActiveWeapon,"weapon_stunstick")) {
		if(baseAct == ACT_MELEE_ATTACK1) {
			return ACT_MELEE_ATTACK_SWING;
		}
		else if(baseAct == ACT_IDLE_ANGRY) {
			return ACT_IDLE_ANGRY_MELEE;
		}
		else {
			return DETOUR_STATIC_CALL(Weapon_TranslateActivity)(entity,baseAct,pRequired);
		}
	}
	else if(FClassnameIs(m_hActiveWeapon,"weapon_crowbar")) {
		if(baseAct == ACT_MELEE_ATTACK1) {
			return ACT_MELEE_ATTACK_SWING;
		}
		else if(baseAct == ACT_IDLE) {
			return ACT_IDLE_ANGRY_MELEE;
		}
		else if(baseAct == ACT_IDLE_ANGRY) {
			return ACT_IDLE_ANGRY_MELEE;
		}
		else {
			return DETOUR_STATIC_CALL(Weapon_TranslateActivity)(entity,baseAct,pRequired);
		}
	}
	else if(FClassnameIs(m_hActiveWeapon,"weapon_pistol")) {
		if(baseAct == ACT_IDLE) {
			return ACT_IDLE_PISTOL;
		}
		else if(baseAct == ACT_IDLE_ANGRY) {
			return ACT_IDLE_ANGRY_PISTOL;
		}
		else if(baseAct == ACT_RANGE_ATTACK1) {
			return ACT_RANGE_ATTACK_PISTOL;
		}
		else if(baseAct == ACT_RANGE_ATTACK1_LOW) {
			return ACT_RANGE_ATTACK_PISTOL_LOW;
		}
		else if(baseAct == ACT_GESTURE_RANGE_ATTACK1) {
			return ACT_GESTURE_RANGE_ATTACK_PISTOL;
		}
		else if(baseAct == ACT_WALK) {
			return ACT_WALK_PISTOL;
		}
		else if(baseAct == ACT_WALK_AIM) {
			return ACT_WALK_AIM_PISTOL;
		}
		else if(baseAct == ACT_RUN) {
			return ACT_RUN_PISTOL;
		}
		else if(baseAct == ACT_RUN_AIM) {
			return ACT_RUN_AIM_PISTOL;
		}
		else if(baseAct == ACT_RELOAD) {
			return ACT_RELOAD_PISTOL;
		}
		else if(baseAct == ACT_RELOAD_LOW) {
			return ACT_RELOAD_PISTOL_LOW;
		}
		else if(baseAct == ACT_GESTURE_RELOAD) {
			return ACT_GESTURE_RELOAD_PISTOL;
		}
		else if(baseAct == ACT_COVER_LOW) {
			return ACT_COVER_PISTOL_LOW;
		}
		else if(baseAct == ACT_RANGE_AIM_LOW) {
			return ACT_RANGE_AIM_PISTOL_LOW;
		}
		else {
			return DETOUR_STATIC_CALL(Weapon_TranslateActivity)(entity,baseAct,pRequired);
		}
	}
	else if(FClassnameIs(m_hActiveWeapon,"weapon_rpg")) {
		if(baseAct == ACT_RANGE_ATTACK1) {
			return ACT_RANGE_ATTACK_RPG;
		}
		else if(baseAct == ACT_IDLE_RELAXED) {
			return ACT_IDLE_RPG_RELAXED;
		}
		else if(baseAct == ACT_IDLE_STIMULATED) {
			return ACT_IDLE_ANGRY_RPG;
		}
		else if(baseAct == ACT_IDLE_AGITATED) {
			return ACT_IDLE_ANGRY_RPG;
		}
		else if(baseAct == ACT_IDLE) {
			return ACT_IDLE_RPG;
		}
		else if(baseAct == ACT_IDLE_ANGRY) {
			return ACT_IDLE_ANGRY_RPG;
		}
		else if(baseAct == ACT_WALK) {
			return ACT_WALK_RPG;
		}
		else if(baseAct == ACT_WALK_CROUCH) {
			return ACT_WALK_CROUCH_RPG;
		}
		else if(baseAct == ACT_RUN) {
			return ACT_RUN_RPG;
		}
		else if(baseAct == ACT_RUN_CROUCH) {
			return ACT_RUN_CROUCH_RPG;
		}
		else if(baseAct == ACT_COVER_LOW) {
			return ACT_COVER_LOW_RPG;
		}
		else {
			return DETOUR_STATIC_CALL(Weapon_TranslateActivity)(entity,baseAct,pRequired);
		}
	}
	if(baseAct == ACT_IDLE) {
		return ACT_IDLE_SMG1;
	}
	else if(baseAct == ACT_IDLE_ANGRY) {
		return ACT_IDLE_ANGRY_SMG1;
	}
	else if(baseAct == ACT_WALK) {
		return ACT_WALK_RIFLE;
	}
	else if(baseAct == ACT_WALK_AIM) {
		return ACT_WALK_AIM_RIFLE;
	}
	else if(baseAct == ACT_RUN) {
		return ACT_RUN_RIFLE;
	}
	else if(baseAct == ACT_RUN_AIM) {
		return ACT_RUN_AIM_RIFLE;
	}
	else if(baseAct == ACT_RELOAD) {
		return ACT_RELOAD_SMG1;
	}
	else if(baseAct == ACT_RELOAD_LOW) {
		return ACT_RELOAD_SMG1_LOW;
	}
	else if(baseAct == ACT_GESTURE_RELOAD) {
		return ACT_GESTURE_RELOAD_SMG1;
	}
	if(FClassnameIs(m_hActiveWeapon,"weapon_ar2")) {
		if(baseAct == ACT_RANGE_ATTACK1_LOW) {
			return ACT_RANGE_ATTACK_AR2_LOW;
		}
		else if(baseAct == ACT_GESTURE_RANGE_ATTACK1) {
			return ACT_GESTURE_RANGE_ATTACK_AR2;
		}
	}
	else if(FClassnameIs(m_hActiveWeapon,"weapon_shotgun")) {
		if(baseAct == ACT_RANGE_ATTACK1_LOW) {
			return ACT_RANGE_ATTACK_SHOTGUN_LOW;
		}
		else if(baseAct == ACT_GESTURE_RANGE_ATTACK1) {
			return ACT_GESTURE_RANGE_ATTACK_SHOTGUN;
		}
	}
	else {
		if(baseAct == ACT_RANGE_ATTACK1_LOW) {
			return ACT_RANGE_ATTACK_SMG1_LOW;
		}
		else if(baseAct == ACT_GESTURE_RANGE_ATTACK1) {
			return ACT_GESTURE_RANGE_ATTACK_SMG1;
		}
	}
	return DETOUR_STATIC_CALL(Weapon_TranslateActivity)(entity,baseAct,pRequired);
}

static const char *g_ppszRandomHeads[] = 
{
	"male_01.mdl",
	"male_02.mdl",
	"female_01.mdl",
	"male_03.mdl",
	"female_02.mdl",
	"male_04.mdl",
	"female_03.mdl",
	"male_05.mdl",
	"female_04.mdl",
	"male_06.mdl",
	"female_06.mdl",
	"male_07.mdl",
	"female_07.mdl",
	"male_08.mdl",
	"male_09.mdl",
};

static const char *g_ppszRandomSpit[] = 
{
	"spitball_large.mdl",
	"spitball_medium.mdl",
	"spitball_small.mdl",
};

static const char *g_ppszModelLocs[] =
{
	//"Group01",
	//"Group02",
	"Group03",
	"Group03m",
};

DETOUR_DECL_STATIC2(UTIL_SetModel, void, CBaseEntity *, pEntity, const char *, pModelName)
{
	if(IsPlayer(pEntity)) {
		DETOUR_STATIC_CALL(UTIL_SetModel)(pEntity,pModelName);
		return;
	}
	if(IsWeapon(pEntity)) {
		CBaseEntity *m_hOwner = GetEntPropEnt(pEntity,"m_hOwner");
		if(m_hOwner != NULL) {
			if(IsPlayer(m_hOwner)) {
				DETOUR_STATIC_CALL(UTIL_SetModel)(pEntity,pModelName);
				return;
			}
			else {
				return;
			}
		}
		DETOUR_STATIC_CALL(UTIL_SetModel)(pEntity,pModelName);
		return;
	}
	const char *newModel = NULL;
	if(FClassnameIs(pEntity,"grenade_spit")) {
		newModel = CFmtStr( "models/%s", g_ppszRandomSpit[rand() % 3] );
	}
	else if(FClassnameIs(pEntity,"npc_antlion")) {
		if(HasSpawnFlags(pEntity,SF_ANTLION_WORKER)) {
			AddSpawnFlags(pEntity,SF_NPC_LONG_RANGE);
			newModel = "models/hl2/antlion_wo.mdl";
		}
	}
	else if(FClassnameIs(pEntity,"npc_combine_s")) {
		if(strcmpi(pModelName,"models/combine_soldier.mdl") == 0){
			newModel = "models/hl2/combine_soldier.mdl";
		}
		else if(strcmpi(pModelName,"models/combine_soldier_prisonguard.mdl") == 0){
			newModel = "models/hl2/combine_soldier_prisonguard.mdl";
		}
		else if(strcmpi(pModelName,"models/combine_super_soldier.mdl") == 0){
			newModel = "models/hl2/combine_super_soldier.mdl";
		}
		else {
			newModel = "models/hl2/combine_soldier.mdl";
		}
	}
	else if(FClassnameIs(pEntity,"npc_citizen")) {
		newModel = CFmtStr( "models/hl2/Humans/%s/%s", g_ppszModelLocs[rand() % 2], g_ppszRandomHeads[rand() % 15] );
	}
	else if(FClassnameIs(pEntity,"npc_stalker")) {
		newModel = "models/hl2/stalker.mdl";
	}
	if(strcmpi(pModelName,"models/police.mdl") == 0) {
		newModel = "models/hl2/police.mdl";
	}
	else if(strcmpi(pModelName,"models/police_cheaple.mdl") == 0) {
		newModel = "models/hl2/police_cheaple.mdl";
	}
	else if(strcmpi(pModelName,"models/barney.mdl") == 0) {
		newModel = "models/hl2/barney.mdl";
	}
	else if(strcmpi(pModelName,"models/breen.mdl") == 0) {
		newModel = "models/hl2/breen.mdl";
	}
	else if(strcmpi(pModelName,"models/breen_monitor.mdl") == 0) {
		newModel = "models/hl2/breen_monitor.mdl";
	}
	else if(strcmpi(pModelName,"models/alyx.mdl") == 0) {
		newModel = "models/hl2/alyx.mdl";
	}
	else if(strcmpi(pModelName,"models/gman.mdl") == 0) {
		newModel = "models/hl2/gman.mdl";
	}
	else if(strcmpi(pModelName,"models/gman_high.mdl") == 0) {
		newModel = "models/hl2/gman_high.mdl";
	}
	else if(strcmpi(pModelName,"models/monk.mdl") == 0) {
		newModel = "models/hl2/monk.mdl";
	}
	else if(strcmpi(pModelName,"models/kleiner.mdl") == 0) {
		newModel = "models/hl2/kleiner.mdl";
	}
	else if(strcmpi(pModelName,"models/eli.mdl") == 0) {
		newModel = "models/hl2/eli.mdl";
	}
	else if(strcmpi(pModelName,"models/monk.mdl") == 0) {
		newModel = "models/hl2/monk.mdl";
	}
	else if(strcmpi(pModelName,"models/mossman.mdl") == 0) {
		newModel = "models/hl2/mossman.mdl";
	}
	else if(strcmpi(pModelName,"models/odessa.mdl") == 0) {
		newModel = "models/hl2/odessa.mdl";
	}
	if(newModel) {
		if(!engine->IsModelPrecached(newModel)) {
			engine->PrecacheModel(newModel,false);
		}
		pModelName = newModel;
	}
	DETOUR_STATIC_CALL(UTIL_SetModel)(pEntity,pModelName);
}

ConVar mp_noblock( "mp_noblock", "1" );

DETOUR_DECL_MEMBER2(ShouldCollide, bool, int, collisionGroup0, int, collisionGroup1)
{
	if ( collisionGroup0 > collisionGroup1 ) {
		int tmp = collisionGroup0;
		collisionGroup0 = collisionGroup1;
		collisionGroup1 = tmp;
	}
	
	if ( collisionGroup0 == COLLISION_GROUP_PLAYER_MOVEMENT && collisionGroup1 == HL2COLLISION_GROUP_SPIT )
		return false;
		
	if ( collisionGroup0 == COLLISION_GROUP_PLAYER_MOVEMENT )
		collisionGroup0 = COLLISION_GROUP_PLAYER;
	
	if( collisionGroup1 == COLLISION_GROUP_PLAYER_MOVEMENT )
		collisionGroup1 = COLLISION_GROUP_PLAYER;
	
	if( collisionGroup0 == COLLISION_GROUP_PLAYER && collisionGroup1 == COLLISION_GROUP_PLAYER ) {
		if(mp_noblock.GetBool())
			return false;
	}
	
	if(collisionGroup0 == COLLISION_GROUP_VEHICLE && collisionGroup1 == COLLISION_GROUP_VEHICLE)
		return false;
	
	if ( collisionGroup1 == COLLISION_GROUP_NPC_ACTOR && collisionGroup0 != COLLISION_GROUP_PLAYER )
		collisionGroup1 = COLLISION_GROUP_NPC;

	if ( collisionGroup0 == HL2COLLISION_GROUP_COMBINE_BALL ) {
		if ( collisionGroup1 == HL2COLLISION_GROUP_COMBINE_BALL )
			return false;
	}

	if ( collisionGroup0 == HL2COLLISION_GROUP_COMBINE_BALL && collisionGroup1 == HL2COLLISION_GROUP_COMBINE_BALL_NPC )
		return false;

	if ( ( collisionGroup0 == COLLISION_GROUP_WEAPON) || ( collisionGroup0 == COLLISION_GROUP_PLAYER ) || ( collisionGroup0 == COLLISION_GROUP_PROJECTILE ) ) {
		if ( collisionGroup1 == HL2COLLISION_GROUP_COMBINE_BALL )
			return false;
	}

	if ( collisionGroup0 == COLLISION_GROUP_DEBRIS ) {
		if ( collisionGroup1 == HL2COLLISION_GROUP_COMBINE_BALL )
			return true;
	}

	if (collisionGroup0 == HL2COLLISION_GROUP_HOMING_MISSILE && collisionGroup1 == HL2COLLISION_GROUP_HOMING_MISSILE )
		return false;

	if ( collisionGroup1 == HL2COLLISION_GROUP_CROW ) {
		if ( collisionGroup0 == COLLISION_GROUP_PLAYER || collisionGroup0 == COLLISION_GROUP_NPC || collisionGroup0 == HL2COLLISION_GROUP_CROW )
			return false;
	}

	if ( ( collisionGroup0 == HL2COLLISION_GROUP_HEADCRAB ) && ( collisionGroup1 == HL2COLLISION_GROUP_HEADCRAB ) )
		return false;

	if ( collisionGroup0 == HL2COLLISION_GROUP_STRIDER && collisionGroup1 == HL2COLLISION_GROUP_STRIDER )
		return false;
		
	if ( collisionGroup0 == HL2COLLISION_GROUP_GUNSHIP && collisionGroup1 == HL2COLLISION_GROUP_GUNSHIP )
		return false;

	if ( collisionGroup0 == COLLISION_GROUP_WEAPON && (collisionGroup1 >= HL2COLLISION_GROUP_FIRST_NPC && collisionGroup1 <= HL2COLLISION_GROUP_LAST_NPC ) )
		return false;

	if ( collisionGroup1 == COLLISION_GROUP_NPC_ACTOR && collisionGroup0 == COLLISION_GROUP_PLAYER )
		return false;

	if ( collisionGroup0 == COLLISION_GROUP_NPC_SCRIPTED && collisionGroup1 == COLLISION_GROUP_NPC_SCRIPTED )
		return false;

	if ( collisionGroup0 == HL2COLLISION_GROUP_SPIT && collisionGroup1 == HL2COLLISION_GROUP_SPIT )
		return false;

	return DETOUR_MEMBER_CALL(ShouldCollide)(collisionGroup0,collisionGroup1);
}

DETOUR_DECL_STATIC1(FindNearestNPC, float, CBaseEntity *, entity)
{
	float flNearest = DETOUR_STATIC_CALL(FindNearestNPC)(entity);
	CBaseEntity *m_hNearestNPC = GetEntPropEnt(entity,"m_hNearestNPC");
	if((flNearest < 246.0) && (m_hNearestNPC == NULL)) {
		flNearest = 60026;
		for(int i=1;i<=gpGlobals->maxClients;i++) {
			CBaseEntity *pPlayer = UTIL_PlayerByIndex(i);
			if((pPlayer != NULL) && !IsFakeClient(pPlayer)) {
				float flDist = (GetAbsOrigin(pPlayer) - GetAbsOrigin(entity) ).LengthSqr();
				if( flDist < flNearest) {
					flNearest = flDist;
					SetEntPropEnt(entity,"m_hNearestNPC",pPlayer);
				}
			}
		}
		CBaseEntity *m_hSprite = GetEntPropEnt(entity,"m_hSprite");
		if(m_hSprite != NULL) {
			servertools->SetKeyValue(m_hSprite,"rendercolor","255 0 0");
			servertools->DispatchSpawn(m_hSprite);
			SetEntProp(entity,"m_bFoeNearest",1,true);
		}
		return sqrt(flNearest);
	}
	return flNearest;
}

ConVar sv_only_one_team("sv_only_one_team","3");

DETOUR_DECL_STATIC2(ChangeTeam, void, CBaseEntity *, entity, int, iTeam)
{
	if((sv_only_one_team.GetInt() != 0) && !IsFakeClient(entity) && (iTeam != 1)) {
		iTeam = sv_only_one_team.GetInt();
	}
	DETOUR_STATIC_CALL(ChangeTeam)(entity,iTeam);
}

DETOUR_DECL_STATIC2(BugBaitTouch, void, CBaseEntity *, entity, CBaseEntity *, pOther)
{
	if(pOther != NULL) {
		if(IsSolidFlagSet(pOther,FSOLID_TRIGGER|FSOLID_VOLUME_CONTENTS)) {
			int m_takedamage = GetEntProp(pOther,"m_takedamage");
			if((m_takedamage == DAMAGE_NO)||(m_takedamage == DAMAGE_EVENTS_ONLY))
				return;
		}
	}
	else {
		return;
	}
	if(FClassnameIs(entity,"grenade_spit")) {
		trace_t *pTrace = &GetTouchTrace(entity);
		CBaseEntity *pTraceEnt = pTrace->m_pEnt;
		trace_t *pNewTrace = const_cast<trace_t*>( pTrace );
		UTIL_DecalTrace( pNewTrace, "BeerSplash" );
		int m_iTeamNum = GetEntProp(entity,"m_iTeamNum");
		if(m_iTeamNum == 3) {
			EmitSound(entity,"NPC_Antlion.PoisonBurstExplode",0.0,NULL);
		}
		if ( pTraceEnt ) {
			
		}
		UTIL_Remove(entity);
		DispatchParticleEffect( GetParticleSystemIndex("blood_impact_antlion_01"), GetAbsOrigin(entity), GetAbsOrigin(entity), vec3_origin, NULL ); 
		return;
	}
	DETOUR_STATIC_CALL(BugBaitTouch)(entity,pOther);
}

class BaseAccessor : public IConCommandBaseAccessor
{
	public:
		bool RegisterConCommandBase(ConCommandBase *pCommandBase)
		{
			return META_REGCVAR(pCommandBase);
		}
} s_BaseAccessor;

bool hl2mp::SDK_OnLoad(char *error, size_t maxlength, bool late)
{
	#if SOURCE_ENGINE >= SE_ORANGEBOX
		g_pCVar = icvar;
		ConVar_Register(0, &s_BaseAccessor);
	#else
		ConCommandBaseMgr::OneTimeInit(&s_BaseAccessor);
	#endif

	char conf_error[255];
	if(!gameconfs->LoadGameConfigFile("sm-hl2mp.games", &g_pGameConf, conf_error, sizeof(conf_error))) {
		if(conf_error[0])
			snprintf(error, maxlength, "Could not read sm-hl2mp.games.txt: %s", conf_error);
		return false;
	}
	CDetourManager::Init(g_pSM->GetScriptingEngine(), g_pGameConf);
	
	AddAmmoTypeHL2MP_CDetour = DETOUR_CREATE_MEMBER(AddAmmoType, "AddAmmoType");
	if(AddAmmoTypeHL2MP_CDetour != NULL) {
		AddAmmoTypeHL2MP_CDetour->EnableDetour();
	}
	else {
		return false;
	}
	
	UTIL_GetLocalPlayer_CDetour = DETOUR_CREATE_STATIC(UTIL_GetLocalPlayer, "UTIL_GetLocalPlayer");
	if(UTIL_GetLocalPlayer_CDetour != NULL) {
		UTIL_GetLocalPlayer_CDetour->EnableDetour();
	}
	else {
		return false;
	}

	SelectSchedule_CDetour = DETOUR_CREATE_STATIC(SelectSchedule, "SelectSchedule");
	if(SelectSchedule_CDetour != NULL) {
		SelectSchedule_CDetour->EnableDetour();
	}
	else {
		return false;
	}
	
	InitDefaultAIRelationshipsHL2MP_CDetour = DETOUR_CREATE_STATIC(InitDefaultAIRelationshipsHL2MP, "InitDefaultAIRelationshipsHL2MP");
	if(InitDefaultAIRelationshipsHL2MP_CDetour != NULL) {
		InitDefaultAIRelationshipsHL2MP_CDetour->EnableDetour();
	}
	else {
		return false;
	}
	
	CapabilitiesGet_CDetour = DETOUR_CREATE_STATIC(CapabilitiesGet, "CapabilitiesGet");
	if(CapabilitiesGet_CDetour != NULL) {
		CapabilitiesGet_CDetour->EnableDetour();
	}
	else {
		return false;
	}
	
	Weapon_TranslateActivity_CDetour = DETOUR_CREATE_STATIC(Weapon_TranslateActivity, "Weapon_TranslateActivity");
	if(Weapon_TranslateActivity_CDetour != NULL) {
		Weapon_TranslateActivity_CDetour->EnableDetour();
	}
	else {
		return false;
	}
	
	UTIL_SetModel_CDetour = DETOUR_CREATE_STATIC(UTIL_SetModel, "UTIL_SetModel");
	if(UTIL_SetModel_CDetour != NULL) {
		UTIL_SetModel_CDetour->EnableDetour();
	}
	else {
		return false;
	}
	
	EmitSound_CDetour = DETOUR_CREATE_STATIC(EmitSound, "EmitSound");
	if(EmitSound_CDetour != NULL) {
		EmitSound_CDetour->EnableDetour();
	}
	else {
		return false;
	}
	
	FireBullets_CDetour = DETOUR_CREATE_STATIC(FireBullets, "FireBullets");
	if(FireBullets_CDetour != NULL) {
		FireBullets_CDetour->EnableDetour();
	}
	else {
		return false;
	}
	
	GetShootEnemyDir_CDetour = DETOUR_CREATE_STATIC(GetShootEnemyDir, "GetShootEnemyDir");
	if(GetShootEnemyDir_CDetour != NULL) {
		GetShootEnemyDir_CDetour->EnableDetour();
	}
	else {
		return false;
	}
	
	ShouldCollide_CDetour = DETOUR_CREATE_MEMBER(ShouldCollide, "ShouldCollide");
	if(ShouldCollide_CDetour != NULL) {
		ShouldCollide_CDetour->EnableDetour();
	}
	else {
		return false;
	}
	
	Operator_HandleAnimEvent_CDetour = DETOUR_CREATE_STATIC(Operator_HandleAnimEvent, "Operator_HandleAnimEvent");
	if(Operator_HandleAnimEvent_CDetour != NULL) {
		Operator_HandleAnimEvent_CDetour->EnableDetour();
	}
	else {
		return false;
	}
	
	HandleAnimEvent_Antlion_CDetour = DETOUR_CREATE_STATIC(HandleAnimEvent_Antlion, "HandleAnimEvent_Antlion");
	if(HandleAnimEvent_Antlion_CDetour != NULL) {
		HandleAnimEvent_Antlion_CDetour->EnableDetour();
	}
	else {
		return false;
	}
	
	FindNearestNPC_CDetour = DETOUR_CREATE_STATIC(FindNearestNPC, "FindNearestNPC");
	if(FindNearestNPC_CDetour != NULL) {
		FindNearestNPC_CDetour->EnableDetour();
	}
	else {
		return false;
	}
	
	ChangeTeam_CDetour = DETOUR_CREATE_STATIC(ChangeTeam, "ChangeTeam");
	if(ChangeTeam_CDetour != NULL) {
		ChangeTeam_CDetour->EnableDetour();
	}
	else {
		return false;
	}
	
	GetSpitVector_CDetour = DETOUR_CREATE_STATIC(GetSpitVector, "GetSpitVector");
	if(GetSpitVector_CDetour != NULL) {
		GetSpitVector_CDetour->EnableDetour();
	}
	else {
		return false;
	}
	
	BugBaitTouch_CDetour = DETOUR_CREATE_STATIC(BugBaitTouch, "BugBaitTouch");
	if(BugBaitTouch_CDetour != NULL) {
		BugBaitTouch_CDetour->EnableDetour();
	}
	else {
		return false;
	}
	
	return true;
}

void hl2mp::SDK_OnUnload()
{
	if(AddAmmoTypeHL2MP_CDetour != NULL) {
		AddAmmoTypeHL2MP_CDetour->Destroy();
		AddAmmoTypeHL2MP_CDetour = NULL;
	}
	
	if(UTIL_GetLocalPlayer_CDetour != NULL) {
		UTIL_GetLocalPlayer_CDetour->Destroy();
		UTIL_GetLocalPlayer_CDetour = NULL;
	}
	
	if(SelectSchedule_CDetour != NULL) {
		SelectSchedule_CDetour->Destroy();
		SelectSchedule_CDetour = NULL;
	}
	
	if(InitDefaultAIRelationshipsHL2MP_CDetour != NULL) {
		InitDefaultAIRelationshipsHL2MP_CDetour->Destroy();
		InitDefaultAIRelationshipsHL2MP_CDetour = NULL;
	}
	
	if(CapabilitiesGet_CDetour != NULL) {
		CapabilitiesGet_CDetour->Destroy();
		CapabilitiesGet_CDetour = NULL;
	}
	
	if(Weapon_TranslateActivity_CDetour != NULL) {
		Weapon_TranslateActivity_CDetour->Destroy();
		Weapon_TranslateActivity_CDetour = NULL;
	}
	
	if(UTIL_SetModel_CDetour != NULL) {
		UTIL_SetModel_CDetour->Destroy();
		UTIL_SetModel_CDetour = NULL;
	}
	
	if(EmitSound_CDetour != NULL) {
		EmitSound_CDetour->Destroy();
		EmitSound_CDetour = NULL;
	}
	
	if(FireBullets_CDetour != NULL) {
		FireBullets_CDetour->Destroy();
		FireBullets_CDetour = NULL;
	}
	
	if(GetShootEnemyDir_CDetour != NULL) {
		GetShootEnemyDir_CDetour->Destroy();
		GetShootEnemyDir_CDetour = NULL;
	}
	
	if(ShouldCollide_CDetour != NULL) {
		ShouldCollide_CDetour->Destroy();
		ShouldCollide_CDetour = NULL;
	}

	if(Operator_HandleAnimEvent_CDetour != NULL) {
		Operator_HandleAnimEvent_CDetour->Destroy();
		Operator_HandleAnimEvent_CDetour = NULL;
	}
	
	if(HandleAnimEvent_Antlion_CDetour != NULL) {
		HandleAnimEvent_Antlion_CDetour->Destroy();
		HandleAnimEvent_Antlion_CDetour = NULL;
	}
	
	if(FindNearestNPC_CDetour != NULL) {
		FindNearestNPC_CDetour->Destroy();
		FindNearestNPC_CDetour = NULL;
	}
	
	if(ChangeTeam_CDetour != NULL) {
		ChangeTeam_CDetour->Destroy();
		ChangeTeam_CDetour = NULL;
	}
	
	if(GetSpitVector_CDetour != NULL) {
		GetSpitVector_CDetour->Destroy();
		GetSpitVector_CDetour = NULL;
	}
	
	if(BugBaitTouch_CDetour != NULL) {
		BugBaitTouch_CDetour->Destroy();
		BugBaitTouch_CDetour = NULL;
	}
	
	gameconfs->CloseGameConfigFile(g_pGameConf);
}

bool hl2mp::SDK_OnMetamodLoad(ISmmAPI *ismm, char *error, size_t maxlen, bool late)
{
	GET_V_IFACE_CURRENT(GetServerFactory, gameents, IServerGameEnts, INTERFACEVERSION_SERVERGAMEENTS);
	GET_V_IFACE_ANY(GetServerFactory, servertools, IServerTools, VSERVERTOOLS_INTERFACE_VERSION);
	GET_V_IFACE_ANY(GetEngineFactory, enginetrace, IEngineTrace, INTERFACEVERSION_ENGINETRACE_SERVER);
	GET_V_IFACE_CURRENT(GetServerFactory, g_pEffects, IEffects, IEFFECTS_INTERFACE_VERSION);
	//GET_V_IFACE_CURRENT(GetEngineFactory, engrandom, IUniformRandomStream, VENGINE_SERVER_RANDOM_INTERFACE_VERSION);
	gpGlobals = ismm->GetCGlobals();
	g_pSharedChangeInfo = engine->GetSharedEdictChangeInfo();

	return true;
}

IChangeInfoAccessor *CBaseEdict::GetChangeAccessor()
{
	return engine->GetChangeAccessor( (const edict_t *)this );
}